package com.logicbig.example;

import org.hamcrest.CoreMatchers;
import org.junit.Assert;
import org.junit.Test;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.List;

public class AppMainTest {
    @Test
    public void appMainTest() {
        String data = "joe.com\n1234\njoe@gmail.com\n123456\ntina@gmail.com\n987654\nexit";
        ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(data.getBytes());
        ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
        PrintStream ps = new PrintStream(byteArrayOutputStream);
        AppMain appMain = new AppMain(byteArrayInputStream, ps);
        appMain.start();
        String output = byteArrayOutputStream.toString();
        assertOutput(output);
    }

    void assertOutput(String output) {
        String lastUserRegistrationBeanInstance = null;
        String[] split = output.split("UserRegistrationBean, instance:");
        Assert.assertThat(split.length, CoreMatchers.is(4));
        for (int i = 0; i < split.length; i++) {
            String sessionOutput = split[i];
            sessionOutput = sessionOutput.trim();
            if (sessionOutput.length() == 0) {
                continue;
            }
            List<String> lines = Arrays.asList(sessionOutput.split("\n"));
            String registrationBeanInstance = lines.get(0).trim();
            Assert.assertNotEquals(registrationBeanInstance, lastUserRegistrationBeanInstance);
            lastUserRegistrationBeanInstance = registrationBeanInstance;
            String result = lines.get(2);
            if (i == 1) {
                Assert.assertThat(result, CoreMatchers.containsString("Error"));
                String errorMsg = result.substring(result.indexOf("["));
                Assert.assertThat(errorMsg,
                        CoreMatchers.is("[Not a valid email: joe.com, Not a valid password. "
                                + "The password should  be alphanumeric and at least 6 characters long ]"));
                AssertSuccess(lines.get(5), "joe@gmail.com", "123456");
            } else if (i == 2) {
                AssertSuccess(lines.get(2), "tina@gmail.com", "987654");
            } else if (i == 3) {//exit
                Assert.assertThat(lines.get(2), CoreMatchers.is("Enter Email>"));
            }
        }
    }

    private void AssertSuccess(String output, String email, String password) {
        String expected = String.format("UserInfo{email='%s', password='%s'}", email, password);
        Assert.assertThat(output, CoreMatchers.containsString(expected));
    }
}